<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph::Application Class Reference</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="classes.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="classes.html"><span>Class&nbsp;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="namespace_sylph.html">Sylph</a>::<a class="el" href="class_sylph_1_1_application.html">Application</a>
  </div>
</div>
<div class="contents">
<h1>Sylph::Application Class Reference</h1><!-- doxytag: class="Sylph::Application" --><!-- doxytag: inherits="Sylph::Object" -->Class representing an application.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="_application_8h-source.html">Sylph/Core/Application.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Sylph::Application:</div>
<div class="dynsection">
<p><center><img src="class_sylph_1_1_application__inherit__graph.png" border="0" usemap="#_sylph_1_1_application__inherit__map" alt="Inheritance graph"></center>
<map name="_sylph_1_1_application__inherit__map">
<area shape="rect" id="node5" href="class_sylph_1_1_application_self.html" title="An Application representing the currently running application." alt="" coords="5,160,168,189"><area shape="rect" id="node2" href="class_sylph_1_1_object.html" title="The root of all classes." alt="" coords="31,5,143,35"></map>
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="class_sylph_1_1_application-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="class_sylph_1_1_string.html">String</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_application.html#86f3f28afa3682734789a12ae578c656">location</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the location of the file containing the object code of the application.  <a href="#86f3f28afa3682734789a12ae578c656"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_application.html#4c4e7adbcf061be18bf1dd99fadf9c0c">init</a> (int argc, char *argv[], char *apple[], <a class="el" href="namespace_sylph.html#8e3a8cf0fd1c1cf417e7834d2a473dc4">AppType</a> type, <a class="el" href="class_sylph_1_1_string.html">String</a> name)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialize the current application.  <a href="#4c4e7adbcf061be18bf1dd99fadf9c0c"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Class representing an application. 
<p>
An application is any file containing executable object code that can be directly invoked by the operating system through a well-defined entry point. Probably the most famous example is the <code>thisapp</code> instance of this class, a pointer to an <a class="el" href="class_sylph_1_1_application.html" title="Class representing an application.">Application</a> object representing the application accessing the pointer.<p>
It is not possible to directly instantiate an <a class="el" href="class_sylph_1_1_application.html" title="Class representing an application.">Application</a> object. Future releases may contain functions to create <a class="el" href="class_sylph_1_1_application.html" title="Class representing an application.">Application</a> objects and run the accompanying object code. <hr><h2>Member Function Documentation</h2>
<a class="anchor" name="4c4e7adbcf061be18bf1dd99fadf9c0c"></a><!-- doxytag: member="Sylph::Application::init" ref="4c4e7adbcf061be18bf1dd99fadf9c0c" args="(int argc, char *argv[], char *apple[], AppType type, String name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Sylph::Application::init           </td>
          <td>(</td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>argc</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&nbsp;</td>
          <td class="paramname"> <em>argv</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&nbsp;</td>
          <td class="paramname"> <em>apple</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespace_sylph.html#8e3a8cf0fd1c1cf417e7834d2a473dc4">AppType</a>&nbsp;</td>
          <td class="paramname"> <em>type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_sylph_1_1_string.html">String</a>&nbsp;</td>
          <td class="paramname"> <em>name</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Initialize the current application. 
<p>
This function will give the correct value to <code>thisapp</code>. Note that if you use int SylphMain(Array&lt;String&gt;) as the entry point for your application (the default), you do not need to call this function explicitly. Instead, it will be called for you before the SylphMain function. Depending on the implementation, this function may or may not set up other important resources. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>argc</em>&nbsp;</td><td>The number of arguments passed to the entry point designated by the platform. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>argv</em>&nbsp;</td><td>An array of C strings containing the arguments passed to the entry point designated by the platform. This array is expected to have a length of argc or more. If argc is larger than the actual length of argv, undefined behaviour may occur. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>apple</em>&nbsp;</td><td>The so-called 'apple-vector', an array of chars unique to the Mac OS X-platform. This array is used to determine the location of the binary solely on the Mac platform and is the fourth argument to the <code>main</code> entry function. On other platforms, this array may be substituted by a <code>null</code> pointer. Substituting this array on the Mac platform for anything else than the actual apple vector passed to the <code>main</code> function may lead to undefined behaviour. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>type</em>&nbsp;</td><td>An enumerated type representing the implementation to use for resource retrieval. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>name</em>&nbsp;</td><td>The name of the application. Used in debug messages and for retrieving configuration files. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="86f3f28afa3682734789a12ae578c656"></a><!-- doxytag: member="Sylph::Application::location" ref="86f3f28afa3682734789a12ae578c656" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="class_sylph_1_1_string.html">String</a> Sylph::Application::location           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the location of the file containing the object code of the application. 
<p>
In case the application for which the location is requested is <code>thisapp</code>, he exact method used to determine the location is platform-dependant and may fail. In this case, the value is either set to an empty string or a garbage value. Depending on the implementation, an error may be raised as well during initialisation. <dl class="return" compact><dt><b>Returns:</b></dt><dd>the application's location. </dd></dl>

</div>
</div><p>
</div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
